#!/bin/sh

BLD=kakasi-2.3.4
PREFIX=c:/kakasi

if test ! -d $BLD ; then
  gzip -cd $BLD.tar.gz | tar xvf -
fi
cd $BLD
patch -p1 < ../$BLD-win32.patch

export ac_cv_prog_LN_S=ln

if test ! -e config.cache ; then
  CC=cl CFLAGS="/nologo /Gf /W3 /MD /O2" ./configure --prefix=$PREFIX --host=i386-windows
fi

make all
make install

mkdir -p $PREFIX/doc
cp -f doc/* $PREFIX/doc
mkdir -p $PREFIX/man/ja/man1
cp -f doc/kakasi.1 $PREFIX/man/ja/man1

sed -e "s/..//g" -e "s/.//g" doc/kakasi.cat > kakasi.cat.TEMPFILE
nkf -J -s -O kakasi.cat.TEMPFILE $PREFIX/kakasi.sjis
rm -f kakasi.cat.TEMPFILE

cp -f COPYING README README-ja NEWS ONEWS $PREFIX/

cd lib
  make clean 2>&1 | tee -a $LOGFILE
  make all 2>&1 | tee -a $LOGFILE
## if test -f kakasi.def ; then
##  nmake -f makefile.msc 2>&1 | tee -a $LOGFILE
##  mkdir -p $PREFIX/lib
##  cp -f libkakasi.lib $PREFIX/lib
##  cp -f kakasi.lib kakasi.dll $PREFIX/lib
## else
  OBJS=`ls *.obj`
  lib -nologo -OUT:libkakasi.lib $OBJS
  mkdir -p $PREFIX/lib
  cp -f libkakasi.lib $PREFIX/lib
  echo "LIBRARY \"kakasi\"" > kakasi.def
  echo "EXPORTS" >> kakasi.def
  for F in $OBJS; do
   nm $F | grep 'T _' | sed 's/.* T _/ /' >> kakasi.def
  done
  cl -nologo -Gf -W3 -O1 -MD -LD -Fekakasi.dll $OBJS -link -def:kakasi.def
  mkdir -p $PREFIX/lib
  cp -f kakasi.lib kakasi.dll $PREFIX/lib
  rm -f kakasi.def
## fi
cd ..
