#!/bin/sh

PREFIX=/namazu
NAMAZU=namazu-2.0.6
CURDIR=`pwd`

if test ! -d $NAMAZU ; then
  tar zxvf $NAMAZU.tar.gz
fi
cd $NAMAZU

if test -z "`type cl 2>&1 | grep 'not found'`" ; then
  rm -f config.cache
  CC="cl" CFLAGS="-nologo -Gf -W3 -O1 -MD -DNO_ALLOCA" LD="lib -nologo" ./configure --prefix=$PREFIX --host=i386-windows --enable-shared=no --disable-nls
  cd lib
    make clean 
    make all 
    OBJS=`ls *.obj`
    lib -nologo -OUT:libnmzut.lib $OBJS
  cd ..

  cd nmz
    make clean 
    make all 
    OBJS=`ls *.obj`
    lib -nologo -OUT:libnmz.lib $OBJS
    mkdir -p $PREFIX/lib
    cp -f libnmz.lib $PREFIX/lib
    echo "LIBRARY \"nmz\"" > nmz.def
    echo "EXPORTS" >> nmz.def
    for F in $OBJS; do
      nm $F | grep 'T _' | sed 's/.* T _/ /' >> nmz.def
    done
    cp -f ../lib/libnmzut.lib .
    cl -nologo -Gf -W3 -O1 -MD -LD -Fenmz.dll $OBJS libnmzut.lib -link -def:nmz.def
    mkdir -p $PREFIX/lib
    cp -f libnmzut.lib nmz.lib nmz.dll $PREFIX/lib
    cp -f nmz.def ../../
  cd ..

fi
