#!/bin/bash

TGT=File-MMagic
BLD=$TGT-1.13
ARC=$BLD.tar.gz
if test ! -d $BLD ; then
	tar xvzf $ARC
fi
cd $BLD

make_program() {
	PERLPATH=$1
	DIR=$2

	$PERLPATH/perl Makefile.PL $3

	nmake
	nmake test
	nmake install
	tar --mode=644 -cvf $TGT.tar blib/*
	gzip --best $TGT.tar
	mv -f $TGT.tar.gz $DIR/x86
	nmake ppd
	sed -e 's#<ABSTRACT></ABSTRACT>#<ABSTRACT>Guess file type from contents</ABSTRACT>#' -e 's#<AUTHOR></AUTHOR>#<AUTHOR>NOKUBI Takatsugu (knok@daionet.gr.jp)</AUTHOR>#' -e 's#<CODEBASE HREF="" />#<CODEBASE HREF="x86/File-MMagic.tar.gz" />#' $TGT.ppd > $TGT.ppd.TEMPFILE
	mv -f $TGT.ppd.TEMPFILE $TGT.ppd
	mv -f $TGT.ppd $DIR
	nmake clean
}

make_program c:/usr/perl628/bin ../600 
make_program c:/usr/perl522/bin ../500 CAPI=TRUE

