#!/perl/bin/perl

$| = 1;
open (STDERR,">&STDOUT");    

print "Content-type: text/plain", "\n\n";

print "\n=== printout opendir(CURDIR,\".\") ===\n";
opendir(CURDIR,".");
rewinddir(CURDIR);
foreach(readdir(CURDIR)){
    next unless /namazu|nmz/i;
    my ($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,
        $atime,$mtime,$ctime,$blksize,$blocks) = stat;
    print "name:$_\n";
    print " dev=$dev ino=$ino mode=$mode nlink=$nlink\n";
    print " uid=$uid gid=$gid rdev=$rdev size=$size\n";
    print " atime=$atime mtime=$mtime ctime=$ctime\n";
    print " blksize=$blksize blocks=$blocks\n";
    if (/\.namazurc/) {
        print "--- printout $_ ---\n";
        open (RC,"<$_") || print "Can not open $_ file !!!\n";
        binmode(RC);
        while (<RC>){print "$_" if /^[^#\s\r\n]/;}
        print "-------------------\n";
    }
}

print "\n=== printout \$ENV ===\n";
foreach(sort keys %ENV) {
    next unless /namazu|nmz|home|lang|path|script|query|server|os|system/i;
    print $_, " = >>>", $ENV{$_}, "<<<\n";
    if (/^NAMAZURC$|^NAMAZUCONF$|^NAMAZUCONFPATH$|^MKNMZRC$/) {
        print "--- printout $ENV{$_} ---\n";
        open (RC,"<$ENV{$_}") || print "Can not open $ENV{$_} file !!!\n";
        binmode(RC);
        while (<RC>){print "$_" if /^[^#\s\r\n]/;}
        print "-------------------------\n";
    }
    if (/^HOME$/) {
        next unless -e "$ENV{$_}/.namazurc";
        print "--- printout $ENV{$_}/.namazurc ---\n";
        open (RC,"<$ENV{$_}/.namazurc")
         || print "Can not open $ENV{$_}/.namazurc file !!!\n";
        binmode(RC);
        while (<RC>){print "$_" if /^[^#\s\r\n]/;}
        print "-----------------------------------\n";
    }
    if (/^ITAIJIDICTPATH$|^KANWADICTPATH$/) {
        next if -e "$ENV{$_}";
        print "Not found $ENV{$_} !!!\n";
    }
}

sub where ($) {
    my $cmd = shift;
    my $pd = ':';
    $pd = ';' if (($^O eq "MSWin32") || ($^O eq "os2"));

    for my $dir (split(/$pd/, $ENV{'PATH'})) {
        next unless $dir;
        print "$dir/$cmd\n" if (-x "$dir/$cmd");
        print "$dir/$cmd.com\n" if (-x "$dir/$cmd.com");
        print "$dir/$cmd.exe\n" if (-x "$dir/$cmd.exe");
        print "$dir/$cmd.bat\n" if (-x "$dir/$cmd.bat");
    }
}

print "\n=== where ===\n";
where "namazu";
where "perl";
where "nkf";
where "kakasi";
where "chasen";
where "mknmz";
where "gcnmz";
where "zcat";
where "gzip";
where "bzip2";
where "groff";
where "jgroff";
where "detex";
where "jstxt";
where "pdftotext";
where "xlhtml";
where "wvhtml";
where "wvversion";
where "ppm";
where "pl2bat";
where "gcc";
where "make";
where "gettext";
where "autoconf";
where "automake";
where "libtool";

sub version ($) {
    my $cmd = shift;

    print "--- $cmd ---\n";
    print `$cmd`;
    print "------------\n";
}

print "\n=== versions ===\n";
version "namazu -v";
version "namazu -C";
version "perl -v";
version "nkf -v";
version "kakasi -v";
# version "chasen -v";
version "mknmz -v";
version "mknmz -C";
version "zcat --version";
version "gzip --version";
#version "bzip2 --version";
version "groff --version";
version "jgroff --version";
#version "detex -v";
#version "jstxt";
version "pdftotext -v";
version "xlhtml";
version "wvhtml";
version "wvversion";
version "gcc --version";
version "make --version";
version "gettext --version";
version "autoconf --version";
version "automake --version";
version "libtool --version";

sub checklib ($) {
    my $libfile = shift;
    for my $path (@INC) {
        my $cpath = "$path/$libfile";
        return 1 if -e "$cpath";
    }
    return 0;
}

print "\n--- File::MMagic ---\n";
if (checklib('File/MMagic.pm')) {
    require File::MMagic;
    print "$File::MMagic::VERSION";
} else {
    print "Not found File::MMagic !!!\n";
}
print "\n--- NKF ---\n";
if (checklib('NKF.pm')) {
    require NKF;
    print "$NKF::VERSION";
} else {
    print "Not found NKF !!!\n";
}
print "\n--- Text::Kakasi ---\n";
if (checklib('Text/Kakasi.pm')) {
    require Text::Kakasi;
    print "$Text::Kakasi::VERSION";
} else {
    print "Not found Text::Kakasi !!!\n";
}
print "\n--- Text::Chasen ---\n";
if (checklib('Text/Chasen.pm')) {
    require Text::Chasen;
    print "$Text::Chasen::VERSION";
} else {
    print "Not found Text::Chasen !!!\n";
}

require IO::Socket;

sub get_method($$) {
    my ($sock, $content) = @_;

    print $sock "HEAD / HTTP/1.0\r\n";
    print $sock "\r\n";

    while (defined($buf = <$sock>)) {
        $$content .= $buf;
    }
    close($sock);
}

print "\n--- web server ---\n";
{
    my $sock = new IO::Socket::INET (
                PeerAddr => '127.0.0.1',
                PeerPort => '80',
                Proto    => 'tcp',
                );
    $sock->autoflush(1);
    if ($sock) {
        my $content;
        get_method($sock, \$content);
        print $content;
    } else {
        print "Not found web server !!!\n";
    }
}

0;

